btrbk improvements for cron
[distro-setup] / btrbk-run
index f0f16bda44f3013bc48ec4ed10c1c1955cbd8d9c..469b1b391afaa73a6b73235a17810b926851484b 100644 (file)
--- a/btrbk-run
+++ b/btrbk-run
@@ -21,6 +21,7 @@ trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
 
+
 usage() {
   cat <<'EOF'
 btrbk-run [OPTIONS]
@@ -35,6 +36,16 @@ EOF
   exit $1
 }
 
+rsync-dirs() {
+  local host=$1
+  local path=$2
+  m rsync $dry_run_arg -ahi --relative --delete "$path" "root@$host:/"
+}
+
+
+m() { if $verbose; then printf "$pre%s\n"  "$*"; fi;  "$@"; }
+die() { printf "$pre%s\n" "$*" >&2;  exit 1; }
+
 # latest $MAIL_HOST
 if [[ -e /b/bash_unpublished/source-semi-priv ]]; then
   source /b/bash_unpublished/source-semi-priv
@@ -62,11 +73,17 @@ if [[ -s $default_args_file ]]; then
   sleep 5
 fi
 
+cron=false
 orig_args=("$@")
-temp=$(getopt -l pull-reexec,help cl:m:nps:t:vh "$@") || usage 1
+temp=$(getopt -l cpull-reexec,help cl:m:npqs:t:vh "$@") || usage 1
 eval set -- "$temp"
 while true; do
   case $1 in
+    --cron)
+      cron=true
+      pre="${0##*/}: "
+      shift
+      ;;
     # only creates the config file, does not run btrbk
     -c) conf_only=true; shift ;;
     # bytes per second, suffix k m g
@@ -85,7 +102,7 @@ while true; do
     -v) verbose=true; verbose_arg=-v; shift ;;
     -h|--help) usage ;;
     --) shift; break ;;
-    *) echo "$0: Internal error!" ; exit 1 ;;
+    *) die "Internal error!" ;;
   esac
 done
 
@@ -93,49 +110,47 @@ done
 cmd_arg=${1:-run}
 
 if [[ -v targets && $source ]]; then
-  echo "$0: error: -t and -s are mutually exclusive" >&2
-  exit 1
+  die "error: -t and -s are mutually exclusive"
 fi
 
-# pull_reexec stops us from getting into an infinite loop if there is some
-# kind of weird problem
-if ! $pull_reexec && [[ $source ]]; then
-  tmpf=$(mktemp)
-  scp $source:/a/bin/distro-setup/btrbk-run $tmpf
-  if diff -q $tmpf $BASH_SOURCE; then
-    echo "$0: found newer version on host $source. reexecing"
-    install -T $tmpf /usr/local/bin/btrbk-run
-    /usr/local/bin/btrbk-run --pull-reexec "${orig_args[@]}"
-  fi
+if $verbose; then
+  printf "$0: options: conf_only=%s\ndry_run=%s\nrate_limit=%s\nverbose=%s\ncmd_arg=%s" "$conf_only" "$dry_run" "$rate_limit" "$verbose" "$cmd_arg"
 fi
-
-
-echo -e "$0: options: conf_only=$conf_only\ndry_run=$dry_run\nrate_limit=$rate_limit\nverbose=$verbose\ncmd_arg=$cmd_arg"
 ### end options parsing
 
 
 # set default targets
-if [[ ! -v targets && ! $source ]]; then
+if [[ ! -v targets && ! $source && $HOSTNAME == $MAIL_HOST ]]; then
   case $HOSTNAME in
-    x2|kw)
-      if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
-        targets=($HOME_DOMAIN)
+    kw|x2)
+      if ping -q -c1 -w1 iank.vpn.office.fsf.org &>/dev/null; then
+        home=iank.vpn.office.fsf.org
+      else
+        home=$HOME_DOMAIN
       fi
+      ;;&
+    kw)
+      targets=($home x2)
+      ;;
+    x2)
+      targets=($home kw)
       ;;
     tp)
-      targets=(frodo)
-      if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
-        if timeout -s 9 10 ssh x2 :; then
-          targets+=(x2)
-        fi
+      targets=(frodo kd)
+      # might not be connected to the vpn
+      if timeout -s 9 10 ssh kw :; then
+        targets+=(kw)
       fi
       ;;
-    frodo)
-      targets=()
+    kd)
+      targets=(frodo tp)
+      # might not be connected to the vpn
+      if timeout -s 9 10 ssh kw :; then
+        targets+=(kw)
+      fi
       ;;
     *)
-      echo "$0: error: no default targets for this host, use -t"
-      exit 1
+      die "error: no default targets for this host, use -t"
       ;;
   esac
 fi
@@ -152,8 +167,7 @@ fi
 if [[ $mountpoints ]]; then
   for mp in ${mountpoints[@]}; do # default mountpoints to sync
     if [[ -e /nocow/btrfs-stale/$mp ]]; then
-      echo "$0: error: $mp is stale, mount-latest-subvol first"
-      exit 1
+      die "error: $mp is stale, mount-latest-subvol first"
     fi
   done
 else
@@ -183,25 +197,39 @@ fi
 
 echo "mountpoints: ${mountpoints[*]}"
 
-##### end command line parsing ########
 
-rsync-dirs() {
-  local host=$1
-  local path=$2
-  m rsync $dry_run_arg -ahi --relative --delete "$path" "root@$host:/"
-}
+
+# pull_reexec stops us from getting into an infinite loop if there is some
+# kind of weird problem
+pulla=false
+for m in "${mountpoints[@]}"; do
+  if [[ $m == /a ]]; then
+    pulla=true
+    break
+  fi
+done
+if ! $pull_reexec && [[ $source ]] && ! $pulla ; then
+  tmpf=$(mktemp)
+  scp $source:/a/bin/distro-setup/btrbk-run $tmpf
+  if ! diff -q $tmpf $BASH_SOURCE; then
+    echo "$0: found newer version on host $source. reexecing"
+    install -T $tmpf /usr/local/bin/btrbk-run
+    m /usr/local/bin/btrbk-run --pull-reexec "${orig_args[@]}"
+    exit
+  fi
+fi
 
 
-m() { printf "%s: %s\n" "${0##*/}" "$*";  "$@"; }
+##### end command line parsing ########
+
 
 
 if ! which btrbk &>/dev/null; then
-  echo "$0: error: no btrbk binary found"
-  exit 1
+  die "error: no btrbk binary found"
 fi
 # if our mountpoints are from stale snapshots,
 # it doesn't make sense to do a backup.
-check-subvol-stale ${mountpoints[@]} || exit 1
+check-subvol-stale ${mountpoints[@]} || die "found stale mountpoints in ${mountpoints[*]}"
 
 
 cat >/etc/btrbk.conf <<EOF
@@ -249,10 +277,12 @@ EOF
 mkdir -p /mnt/root/btrbk
 local_zone=$(date +%z)
 for h in ${targets[@]} $source; do
-  zone=$(ssh root@$h "mkdir -p /mnt/root/btrbk; date +%z")
+  cmd="ssh root@$h mkdir -p /mnt/root/btrbk && date +%z"
+  if ! zone=$($cmd); then
+    die "error running: $cmd"
+  fi
   if [[ $zone != $local_zone ]]; then
-    echo "error: error. dont confuse yourself with multiple time zones. $h has different timezone than localhost" >&2
-    exit 1
+    die "error: dont confuse yourself with multiple time zones. $h has different timezone than localhost"
   fi
 done
 
@@ -324,9 +354,8 @@ if mountpoint $rsync_mountpoint >/dev/null; then
   done
 fi
 
-/a/bin/distro-setup/install-my-scripts
 if [[ $source ]]; then
-  m mount-latest-subvol
+  m mount-latest-subvol $verbose_arg
 else
   m /a/exe/mount-latest-remote ${targets[@]}
 fi